#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <cups/cups.h>
#include <stdio.h>
#include <string.h>

#include <dirent.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "coda.h"
#include "docklet.h"


//int check_skin(char *skin);

void
on_esci1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(system_tray==0)
  {
	  gqueuepref_write (&pref);
	  exit(0);
  }
  else
  {
	  docklet_toggle();
  }
}


void
on_elimina1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkButton       *button;
	
	on_buttonElimina_clicked(button,user_data);
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{	
  info = create_Info ();	
  gtk_widget_show (info);
}


int
queue_refresh				( void )

{
	int i,printing,num_jobs,num_dests,mypid,ID;
	cups_job_t *jobs;
	cups_dest_t *dests,*dest;
	gchar  *mydest, *lock_file_name,*myhome,*stringa/*[64]*/,*Stampante,*stato/*[20]*/;
	GtkTreeIter   iter,iter2;  
	GtkTreeSelection *select;
    GtkTreeModel *model;
	FILE *lock_file_descriptor;
	
	// lock file exist?
	myhome = getenv ("HOME");
	mypid=getpid();
	lock_file_name = g_strdup_printf ("%s/%s.%d", myhome, ".gqueue-lock",mypid);
	if((lock_file_descriptor = fopen(lock_file_name,"r"))==NULL)
	{
		// lock file don't exists then I exit
	    exit(0);
	}
	fclose(lock_file_descriptor);
    g_free(myhome);
    g_free(lock_file_name);
	
	num_dests = cupsGetDests(&dests);
	if(num_dests<1) exit(-1);
	dest = cupsGetDest(NULL, NULL, num_dests, dests);
	  
	//strncpy(stringa,gtk_entry_get_text (GTK_ENTRY(GTK_COMBO (lookup_widget ( GTK_WIDGET(FinestraPrincipale), "combo1" ))->entry)),63);
	//stringa[63]='\n';
	stringa = g_strdup_printf ("%s",
	     	  gtk_entry_get_text (GTK_ENTRY(lookup_widget ( FinestraPrincipale, "combo_entry1" ))));
	
	mydest = g_strdup_printf ("%s", stringa);
	//mydest = g_strdup_printf ("%s",
	//	gtk_entry_get_text (GTK_ENTRY(lookup_widget ( FinestraPrincipale, "combo_entry1" ))));
	
	
	if ( !strcmp(stringa,_("Tutte le stampanti")))
	{
		mydest=NULL;
	}
	
	if ( !strcmp(stringa,_("Stampante di default")))
	{
		mydest=dest->name;
	}
	
	num_jobs = cupsGetJobs(&jobs, mydest, 0, 0);
	//printf("%d active job(s):\n", num_jobs);
	if (num_jobs == 0)
	{
	  if(system_tray==1) docklet_update_status((enum docklet_status)stopped);
	}
	
	// Salvo l'informazione sulla riga selezionata (da riselezionare dopo se ancora esistente)
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW (tree));
	if (gtk_tree_selection_get_selected (select, &model, &iter2))
        {
                gtk_tree_model_get (model, &iter2, 0, &Stampante, -1);
			    gtk_tree_model_get (model, &iter2, 1, &ID, -1);
        }
	else
	{
		Stampante = NULL;
		ID=-1;
	}

	
	printing=0;
	gtk_list_store_clear(GTK_LIST_STORE(store));
	for (i = 0; i < num_jobs; i ++)
	{
		/*printf("%-16.16s %-6d %-12.12s %s (%s)\n", jobs[i].dest, jobs[i].id,
			 jobs[i].user, jobs[i].title,
			 jobs[i].state != IPP_JOB_PENDING ? "printing" : "pending");*/
		
		if(jobs[i].state==IPP_JOB_PENDING) {
		  //strcpy(stato,_("In attesa"));
		  	stato = g_strdup_printf ("%s", _("In attesa"));		
		}
		else {
		  //strcpy(stato,_("In stampa"));
			stato = g_strdup_printf ("%s", _("In stampa"));	
		  printing=1;
		}
		gtk_list_store_insert (GTK_LIST_STORE(store), &iter,i);
        gtk_list_store_set (GTK_LIST_STORE(store), &iter,
											   STAMPANTE_COLUMN,jobs[i].dest,
											   ID_COLUMN,jobs[i].id,
											   UTENTE_COLUMN,jobs[i].user,
											   TITOLO_COLUMN,jobs[i].title,
											   STATO_COLUMN,stato,
											   -1);
		
		// Ripristina selezione
		if (jobs[i].id == ID && (!strcmp (jobs[i].dest, Stampante)))
		{	
			gtk_tree_selection_select_iter(select, &iter);
		}
	}
	
	if(system_tray==1 && printing==1)
	{	
		if(icon_flash==0) docklet_update_status((enum docklet_status)printing);
		if(icon_flash==1) docklet_update_status((enum docklet_status)stopped);
		if(icon_flash==0) icon_flash=1; else icon_flash=0;
	}
	if(system_tray==1 && printing==0) docklet_update_status((enum docklet_status)stopped);
	
	cupsFreeJobs(num_jobs, jobs);
	cupsFreeDests(num_dests, dests);
	g_free (Stampante);
	
	return(1);
}

// mette nel combobox delle stampanti l'elenco delle stampanti disponibili
void
combo_init				( void )

{
	
	GList *glist = NULL;
	cups_dest_t *dests,*dest;
	int num_dests,i;

	glist = g_list_append (glist, _("Stampante di default"));
	glist = g_list_append (glist, _("Tutte le stampanti"));
	
	num_dests = cupsGetDests(&dests);
	dest      = cupsGetDest(NULL, NULL, num_dests, dests);
	
	for(i=0;i<num_dests;i++)
	{
		glist = g_list_append (glist,dests[i].name);
		gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget ( GTK_WIDGET(FinestraPrincipale), "combo1" )), glist);
	}
	
		g_list_free(glist);
		cupsFreeDests(num_dests, dests);
	
}

// mette nel combobox delle icone quelle disponibili e seleziona la skin attiva 
void combo_icone_init ( void )
{
	lista_skin_nomi = NULL;
	no_local_skin = 0;
	combo_icone_init_datadir();
	combo_icone_init_home();
	g_list_free(lista_skin_nomi);
	
	//seleziona la stringa attiva
	gtk_entry_set_text( GTK_ENTRY(lookup_widget ( GTK_WIDGET(icone), "combo_entry2" )),skinname);
}


void combo_icone_init_datadir ( void )
{	
	// variabili per la lettura delle directory delle skin
	DIR *dp;
    struct dirent *ep;
	gchar *dirname, *filename;
	
	// icone disponibili nella cartella DATADIR
	dirname = g_build_filename(DATADIR, "pixmaps/gqueue/", NULL);
	dp = opendir (dirname);
    if (dp != NULL)
    {
      while (ep = readdir (dp))
	  {
		  filename = g_build_filename(dirname, ep->d_name, NULL);
		  if( check_skin(filename) )
		  {
			  lista_skin_nomi = g_list_append (lista_skin_nomi,g_build_filename(ep->d_name, NULL));
		  }
	  }
    
      closedir (dp);
	  g_free(ep);
    }
    else
	{
		printf("Couldn't open the directory %s\n",dirname);
		printf("Install error\n");
		exit(-1);
	}
	
	gtk_combo_set_popdown_strings
		(GTK_COMBO (lookup_widget ( GTK_WIDGET(icone), "combo2" )),lista_skin_nomi);
	
	g_free(dirname);
	g_free(filename);
	
}

// mette nel combobox delle icone quelle disponibili
void combo_icone_init_home ( void )
{	
	// variabili per la lettura delle directory delle skin
	DIR *dp;
    struct dirent *ep;
	gchar *dirname, *filename;
	
	// icone dispnibili nella cartella DATADIR
	dirname = g_build_filename(getenv("HOME"), ".gqueue-skin/", NULL);
	dp = opendir (dirname);
    if (dp != NULL)
    {
      while (ep = readdir (dp))
	  {
		  filename = g_build_filename(dirname, ep->d_name, NULL);
		  if( check_skin(filename) )
		  {
			  lista_skin_nomi = g_list_append (lista_skin_nomi,g_build_filename(ep->d_name, NULL));		  
		  }
	  }
    
      closedir (dp);
	  g_free(ep);
    }
    else
	{
		printf("Couldn't open the directory %s\n",dirname);
		return;
	}
	
	gtk_combo_set_popdown_strings
		(GTK_COMBO (lookup_widget ( GTK_WIDGET(icone), "combo2" )),lista_skin_nomi);
	
	g_free(dirname);
	g_free(filename);
	
}


void
on_buttonEsci_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	if(system_tray==0)
  	{
	  gqueuepref_write (&pref);
	  exit(0);
	 
  	}
	else
  {
	  docklet_toggle();
  }
}



void
on_buttonElimina_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkTreeIter iter;
    GtkTreeModel *model;
    gchar *Stampante;
	int ID;
	GtkTreeSelection *select;
	

    select = gtk_tree_view_get_selection (GTK_TREE_VIEW (tree));

        if (gtk_tree_selection_get_selected (select, &model, &iter))
        {
                gtk_tree_model_get (model, &iter, 0, &Stampante, -1);
			    gtk_tree_model_get (model, &iter, 1, &ID, -1);

				cupsCancelJob(Stampante, ID);   
			
                g_free (Stampante);
				queue_refresh();
        }

}


void
on_buttonInfo_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	  info = create_Info ();	
	  gtk_widget_show (info);
}



void
on_buttonChiudi_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(info);
}


void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	queue_refresh();
}


gboolean
on_gqueue_delete_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  if(system_tray==1)
  {
	  docklet_toggle();
	  return TRUE;
  }
  else
  {
	  exit(0);
	  return FALSE;
  }
}


gboolean
on_Info_delete_event                   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_destroy(info);
  return FALSE;
}



gboolean
on_gqueue_window_state_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{ 
	if(semaforo_window_state_event==0)
	{
	
		if( system_tray==1
		    && event->window_state.changed_mask == GDK_WINDOW_STATE_ICONIFIED
	        && event->window_state.new_window_state == GDK_WINDOW_STATE_ICONIFIED )
		{
			semaforo_window_state_event=1;
			gtk_widget_hide (FinestraPrincipale);
		}
    }
	else semaforo_window_state_event=0; 
}

void
system_tray_on()
{
	if(system_tray==0)
	{
		system_tray=1;
		docklet_register_icon_factory_skin(skin);
		docklet_create(FinestraPrincipale);
		docklet_toggle();
	}
}

void
system_tray_off()
{
	if(system_tray==1)
	{
		system_tray=0;
		docklet_delete();
	}
}


void
on_in_system_tray_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    if(semaforo==0)
	{
		if(system_tray==0)
			system_tray_on();
		else
			system_tray_off();
	
		// Save pref.
		pref.system_tray = system_tray;
		gqueuepref_write (&pref);
    }
}




gboolean
on_gqueue_destroy_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  return FALSE;
}


void
on_icone_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    combo_icone_init();
	gtk_widget_show (icone);
}

// bottone sfoglia dentro alla finestra di selezione icone
void
on_buttonSfoglia_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *dirname;
	
	dirname = g_build_filename(getenv("HOME"),"/", NULL);

	fileselection1 = create_fileselection1 ();
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection1),dirname);
    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(fileselection1));	
    gtk_widget_show (fileselection1);
}

// bottone annulla dentro alla finestra di selezione icone
void
on_buttonAnnulla_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_hide (icone);
}

// bottone OK dentro alla finestra di selezione icone cio applica nuove icone e chiudi
void
on_buttonOK_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	
	skinname = g_build_filename(gtk_entry_get_text
		(GTK_ENTRY(GTK_COMBO (lookup_widget ( GTK_WIDGET(icone), "combo2" ))->entry)),
		NULL);

	gtk_widget_hide (icone);
	skin = g_build_filename(DATADIR, "pixmaps/gqueue/",skinname,"/", NULL);
	if(!check_skin(skin))
	{
		g_free(skin);
		skin = g_build_filename(getenv("HOME"), ".gqueue-skin/",skinname,"/", NULL);
		if(!check_skin(skin))
		{
			printf("Problem in using icons '%s', set to default\n",skinname);
			g_free(skin);
	        g_free(skinname);
			skinname= g_build_filename("default", NULL);
			skin= g_build_filename(DATADIR, "pixmaps/gqueue/default/", NULL);
		}
	}
	
	if(system_tray==1)
		{
			system_tray_off();
		    system_tray_on();	
			docklet_toggle();			
		}
	
	pref.icons=g_build_filename(skinname, NULL);
	gqueuepref_write (&pref);
}

// bottone Applica dentro alla finestra di selezione icone cio applica nuove icone
void
on_buttonApplica_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	on_buttonOK_clicked (button,user_data);
	gtk_widget_show(icone);
}



// bottone OK dentro alla finestra di selezione file, cio installazione skin
void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cartella_sorgente,*command,*skinname_to_install, *dirname;
	DIR *dp;
	
	cartella_sorgente = g_build_filename
	                    (gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselection1)),
	                    NULL);
	
	if(check_skin(cartella_sorgente))
	{ 
		
		skinname_to_install = prendi_nome_skin(cartella_sorgente);
		
		dirname = g_build_filename(DATADIR, "pixmaps/gqueue/",skinname_to_install, NULL);
	    dp = opendir (dirname);
        if (dp != NULL)
		{
			gtk_label_set_text(GTK_LABEL (lookup_widget ( GTK_WIDGET(dialog1), "dialog_label" )),
				_("Error: selected icon set is already installed"));
			gtk_widget_show(dialog1);
			
			closedir(dp);
			gtk_widget_destroy(fileselection1);
			g_free(cartella_sorgente);
			g_free(skinname_to_install);
			g_free(dirname);
			return;
		}
		else
	    {
			// create skin dir (if not exists)
			command = g_build_filename
					  ("mkdir ",getenv("HOME"),".gqueue-skin", NULL);
			system(command);
			
			// copy skin folder in local skin dir
			command = g_build_filename
					  ("cp -r ",cartella_sorgente," ",getenv("HOME"),".gqueue-skin", NULL);
			system(command);
			
			g_free(command);
			g_free(dirname);
			g_free(skinname_to_install);
		}
	}
	else
	{
		gtk_label_set_text(GTK_LABEL (lookup_widget ( GTK_WIDGET(dialog1), "dialog_label" )),
				_("Error:\nSelected folder is\nnot a valid icon\nfolder for gQueue"));
		gtk_widget_show(dialog1);
	}
	gtk_widget_destroy(fileselection1);
	g_free(cartella_sorgente);
	combo_icone_init();
}


// data un percorso tipo '/foo/pippo/pluto/' return 'pluto'
gchar *prendi_nome_skin(gchar *cartella_sorgente)
{
	gchar *nome_skin;
	int lungh=0,inizio=0,i;
	
	while(cartella_sorgente[lungh] != 0)
	{
		if(cartella_sorgente[lungh]=='/' && cartella_sorgente[lungh+1]!= 0) inizio=lungh+1;
		lungh++;
	}
	
	//tanto per allocare lo spazio sufficiente
	nome_skin =  g_build_filename (cartella_sorgente, NULL);
	lungh=lungh-inizio;
	for(i=0;i<=lungh;i++)
	{
		if(cartella_sorgente[inizio+i] != '/') nome_skin[i] = cartella_sorgente[inizio+i];
		else { nome_skin[i] = 0; i++; }
	}
	
	return(nome_skin);
}


// bottoni cancel e OK dentro alla finestra di selezione file
void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy(fileselection1);
}

void
on_okbutton1_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_hide(dialog1);
}

// cambia la entry delle icone, bisogna cambiare la preview
void
on_combo_entry2_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gchar *nomeskin,*nomefile1,*nomefile2,*nomefileinfo,*nomedir;
	
	// filename
	nomeskin = g_build_filename(gtk_entry_get_text
		(GTK_ENTRY(GTK_COMBO (lookup_widget ( GTK_WIDGET(icone), "combo2" ))->entry)),
		NULL);
	nomedir = g_build_filename(DATADIR, "pixmaps/gqueue/",nomeskin,"/",NULL);
	nomefile1 = g_build_filename(nomedir,"gqueue.png",NULL);
	nomefile2 = g_build_filename(nomedir,"gqueue-printing.png",NULL);
	nomefileinfo = g_build_filename(nomedir,"info.txt",NULL);
	if(!check_skin(nomedir))
	{
		g_free(nomedir);
		g_free(nomefile1);
		g_free(nomefile2);
		g_free(nomefileinfo);
		nomedir = g_build_filename(getenv("HOME"), ".gqueue-skin/",nomeskin,"/", NULL);
		nomefile1 = g_build_filename(nomedir,"gqueue.png",NULL);
		nomefile2 = g_build_filename(nomedir,"gqueue-printing.png",NULL);
		nomefileinfo = g_build_filename(nomedir,"info.txt",NULL);
	}

	// set icons and comment (info.txt)
	aggiorna_text_view_info(nomefileinfo);
	gtk_image_set_from_file(GTK_IMAGE(lookup_widget ( GTK_WIDGET(icone), "image15" )),nomefile1);
	gtk_image_set_from_file(GTK_IMAGE(lookup_widget ( GTK_WIDGET(icone), "image16" )),nomefile2);
	
}

void aggiorna_text_view_info(gchar *nomefileinfo)
{
	GtkTextBuffer *buffer;
	FILE *file_pointer;
	gchar *lettera;
	
	buffer = gtk_text_view_get_buffer 
	         (GTK_TEXT_VIEW (lookup_widget ( GTK_WIDGET(icone), "textviewInfoSkin" )));
	
	gtk_text_buffer_set_text(buffer,"",-1);
	
	lettera = g_malloc (3);
	
	if ((file_pointer = fopen (nomefileinfo, "r")) != NULL)
	{
		while( fgets(lettera,2,file_pointer) != NULL )
		{
			gtk_text_buffer_insert_at_cursor(buffer,lettera,-1);
		}
		
	}
	else
	{
		gtk_text_buffer_set_text (buffer, "No info.txt file.", -1);
	}
	
	g_free (lettera);
	
}

gboolean
on_icone_delete_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_hide(icone);
  return TRUE;
}

gint item_press (GtkWidget *widget, GdkEvent *event)
{
	GtkWidget *menu;
	
	/* convert GdkEvent to GdkEventButton */
    GdkEventButton *bevent = (GdkEventButton *) event;
	
	// button pressed is 3
	if (bevent->button == 3)
	{
      /* stuff to do when the 3rd button (right button) is pressed */
      
	  menu = create_context_menu();
	  gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL,
						  bevent->button, bevent->time);
	
	}
		
	return FALSE;

	
}


void
on_context_elimina_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkButton       *button;
	
	on_buttonElimina_clicked(button,user_data);
}


void
on_context_esci_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_esci1_activate(menuitem,user_data);
}

void
on_esci_context_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gqueuepref_write (&pref);
	exit(0);
}
