/* docklet.h
 * Contributed by Line72 <line72@line72.homelinux.com>
 */

#ifndef __DOCKLET_H__
#define __DOCKLET_H__

#include <gtk/gtk.h>
#include "eggtrayicon.h"

enum docklet_status {
  stopped,
  printing
};

/* globals for the tray icon */
static EggTrayIcon *docklet = NULL;
static GtkWidget *image = NULL;
static GtkIconFactory *icon_factory = NULL;
static enum docklet_status status;

static GtkWidget *main_window = NULL;
static char DATADIR[255]=PACKAGE_DATA_DIR;

/* function declarations */
gboolean docklet_create(GtkWidget *win);
void docklet_update_status(enum docklet_status new_status);
static void docklet_update_icon();
static void docklet_clicked(GtkWidget *button, GdkEventButton *event, void *data);
void docklet_toggle();
static void docklet_hide();
static void docklet_unhide();

static void docklet_register_icon(const char *name, char *fn);
void docklet_register_icon_factory();
static void docklet_unregister_icon_factory();

static void docklet_remove_callbacks();
static void docklet_embedded(GtkWidget *widget, void *data);
static void docklet_destroyed(GtkWidget *widget, void *data);
void docklet_delete();

//skin
void docklet_register_icon_factory_skin(char *name);
static void docklet_register_icon_filename(const char *name, char *fn);

#endif /* __DOCKLET_H__ */
